import { FrontendApplicationContribution, FrontendApplication, KeybindingContribution, KeybindingRegistry } from "@wiptheia/core/lib/browser";
import { CommandContribution, CommandRegistry, Command, MenuContribution, MenuModelRegistry, Disposable } from '@wiptheia/core/lib/common';
import { BlameDecorator } from './blame-decorator';
import { EditorManager, EditorWidget } from '@wiptheia/editor/lib/browser';
import { BlameManager } from './blame-manager';
import URI from '@wiptheia/core/lib/common/uri';
export declare namespace BlameCommands {
    const SHOW_GIT_ANNOTATIONS: Command;
    const CLEAR_GIT_ANNOTATIONS: Command;
}
export declare class BlameContribution implements FrontendApplicationContribution, CommandContribution, KeybindingContribution, MenuContribution {
    protected readonly editorManager: EditorManager;
    protected readonly decorator: BlameDecorator;
    protected readonly blameManager: BlameManager;
    onStart(app: FrontendApplication): void;
    registerCommands(commands: CommandRegistry): void;
    protected readonly currentFileEditorWidget: EditorWidget | undefined;
    protected isBlameable(uri: string | URI): boolean;
    protected appliedDecorations: Map<string, Disposable>;
    protected showBlame(editorWidget: EditorWidget): Promise<void>;
    protected clearBlame(uri: string | URI): void;
    registerMenus(menus: MenuModelRegistry): void;
    registerKeybindings(keybindings: KeybindingRegistry): void;
}
