import { CommandRegistry, Command, MenuModelRegistry, SelectionService, MessageService } from "@wiptheia/core/lib/common";
import { FrontendApplication, AbstractViewContribution } from '@wiptheia/core/lib/browser';
import { WidgetManager } from '@wiptheia/core/lib/browser/widget-manager';
import { GitDiffWidget } from './git-diff-widget';
import { OpenerService } from "@wiptheia/core/lib/browser";
import { UriCommandHandler, UriAwareCommandHandler } from '@wiptheia/core/lib/common/uri-command-handler';
import { GitQuickOpenService } from '../git-quick-open-service';
import { FileSystem } from "@wiptheia/filesystem/lib/common";
import URI from '@wiptheia/core/lib/common/uri';
import { Git } from "../../common";
export declare namespace GitDiffCommands {
    const OPEN_FILE_DIFF: Command;
}
export declare class GitDiffContribution extends AbstractViewContribution<GitDiffWidget> {
    protected readonly selectionService: SelectionService;
    protected readonly widgetManager: WidgetManager;
    protected readonly app: FrontendApplication;
    protected readonly quickOpenService: GitQuickOpenService;
    protected readonly fileSystem: FileSystem;
    protected openerService: OpenerService;
    protected readonly notifications: MessageService;
    constructor(selectionService: SelectionService, widgetManager: WidgetManager, app: FrontendApplication, quickOpenService: GitQuickOpenService, fileSystem: FileSystem, openerService: OpenerService, notifications: MessageService);
    registerMenus(menus: MenuModelRegistry): void;
    registerCommands(commands: CommandRegistry): void;
    showWidget(options: Git.Options.Diff): Promise<GitDiffWidget>;
    protected newUriAwareCommandHandler(handler: UriCommandHandler<URI>): UriAwareCommandHandler<URI>;
}
