"use strict";
/*
 * Copyright (C) 2018 TypeFox and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 */
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var git_diff_contribution_1 = require("./git-diff-contribution");
var browser_1 = require("@wiptheia/core/lib/browser");
var core_1 = require("@wiptheia/core");
var git_diff_widget_1 = require("./git-diff-widget");
require("../../../src/browser/style/diff.css");
function bindGitDiffModule(bind) {
    bind(git_diff_widget_1.GitDiffWidget).toSelf();
    bind(browser_1.WidgetFactory).toDynamicValue(function (ctx) { return ({
        id: git_diff_widget_1.GIT_DIFF,
        createWidget: function () { return ctx.container.get(git_diff_widget_1.GitDiffWidget); }
    }); });
    bind(git_diff_contribution_1.GitDiffContribution).toSelf().inSingletonScope();
    try {
        for (var _a = __values([core_1.CommandContribution, core_1.MenuContribution]), _b = _a.next(); !_b.done; _b = _a.next()) {
            var identifier = _b.value;
            bind(identifier).toDynamicValue(function (ctx) {
                return ctx.container.get(git_diff_contribution_1.GitDiffContribution);
            }).inSingletonScope();
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var e_1, _c;
}
exports.bindGitDiffModule = bindGitDiffModule;
//# sourceMappingURL=git-diff-frontend-module.js.map