import { VirtualWidget } from "@wiptheia/core/lib/browser";
import { GitFileStatus, GitFileChange } from '../common';
import URI from "@wiptheia/core/lib/common/uri";
import { GitRepositoryProvider } from "./git-repository-provider";
import { LabelProvider } from "@wiptheia/core/lib/browser/label-provider";
import { Message } from "@phosphor/messaging";
export declare class GitNavigableListWidget<T extends {
    selected?: boolean;
}> extends VirtualWidget {
    protected gitNodes: T[];
    private _scrollContainer;
    protected readonly repositoryProvider: GitRepositoryProvider;
    protected readonly labelProvider: LabelProvider;
    constructor();
    protected onActivateRequest(msg: Message): void;
    protected scrollContainer: string;
    protected onUpdateRequest(msg: Message): void;
    protected getStatusCaption(status: GitFileStatus, staged?: boolean): string;
    protected getAbbreviatedStatusCaption(status: GitFileStatus, staged?: boolean): string;
    protected relativePath(uri: URI | string): string;
    protected computeCaption(fileChange: GitFileChange): string;
    protected onAfterAttach(msg: Message): void;
    protected navigateLeft(): void;
    protected navigateRight(): void;
    protected navigateUp(): void;
    protected navigateDown(): void;
    protected handleListEnter(): void;
    protected getSelected(): T | undefined;
    protected selectNode(node: T): void;
    protected selectNextNode(): void;
    protected selectPreviousNode(): void;
    protected readonly indexOfSelected: number;
}
