import { interfaces } from 'inversify';
import { PreferenceProxy, PreferenceService, PreferenceSchema } from '@wiptheia/core/lib/browser';
export declare const GitConfigSchema: PreferenceSchema;
export interface GitConfiguration {
    'git.decorations.enabled': boolean;
    'git.decorations.colors': boolean;
    'git.editor.decorations.enabled': boolean;
    'git.editor.dirtydiff.linesLimit': number;
}
export declare const GitPreferences: unique symbol;
export declare type GitPreferences = PreferenceProxy<GitConfiguration>;
export declare function createGitPreferences(preferences: PreferenceService): GitPreferences;
export declare function bindGitPreferences(bind: interfaces.Bind): void;
