"use strict";
/*
 * Copyright (C) 2017 TypeFox and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var virtualdom_1 = require("@phosphor/virtualdom");
var uri_1 = require("@wiptheia/core/lib/common/uri");
var core_1 = require("@wiptheia/core");
var browser_1 = require("@wiptheia/core/lib/browser");
var browser_2 = require("@wiptheia/editor/lib/browser");
var browser_3 = require("@wiptheia/workspace/lib/browser");
var common_1 = require("../common");
var git_watcher_1 = require("../common/git-watcher");
var git_resource_1 = require("./git-resource");
var git_repository_provider_1 = require("./git-repository-provider");
var git_commit_message_validator_1 = require("./git-commit-message-validator");
var git_avatar_service_1 = require("./history/git-avatar-service");
var GitFileChangeNode;
(function (GitFileChangeNode) {
    function is(node) {
        return !!node && 'uri' in node && 'status' in node && 'description' in node && 'label' in node && 'icon' in node;
    }
    GitFileChangeNode.is = is;
})(GitFileChangeNode = exports.GitFileChangeNode || (exports.GitFileChangeNode = {}));
var GitWidget = /** @class */ (function (_super) {
    __extends(GitWidget, _super);
    function GitWidget(git, gitWatcher, contextMenuRenderer, resourceProvider, messageService, commandService, repositoryProvider, labelProvider, workspaceService, avatarService, commitMessageValidator) {
        var _this = _super.call(this) || this;
        _this.git = git;
        _this.gitWatcher = gitWatcher;
        _this.contextMenuRenderer = contextMenuRenderer;
        _this.resourceProvider = resourceProvider;
        _this.messageService = messageService;
        _this.commandService = commandService;
        _this.repositoryProvider = repositoryProvider;
        _this.labelProvider = labelProvider;
        _this.workspaceService = workspaceService;
        _this.avatarService = avatarService;
        _this.commitMessageValidator = commitMessageValidator;
        _this.stagedChanges = [];
        _this.unstagedChanges = [];
        _this.mergeChanges = [];
        _this.message = '';
        _this.messageBoxHeight = GitWidget_1.MESSAGE_BOX_MIN_HEIGHT;
        _this.id = 'theia-gitContainer';
        _this.title.label = 'Git';
        _this.scrollContainer = 'changesOuterContainer';
        _this.addClass('theia-git');
        return _this;
    }
    GitWidget_1 = GitWidget;
    GitWidget.prototype.init = function () {
        var _this = this;
        this.toDispose.push(this.repositoryProvider.onDidChangeRepository(function (repository) {
            return _this.initialize(repository);
        }));
        this.initialize(this.repositoryProvider.selectedRepository);
        this.update();
    };
    GitWidget.prototype.initialize = function (repository) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!repository) return [3 /*break*/, 2];
                        this.toDispose.dispose();
                        _b = (_a = this.toDispose).push;
                        return [4 /*yield*/, this.gitWatcher.watchGitChanges(repository)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        this.toDispose.push(this.gitWatcher.onGitEvent(function (gitEvent) { return __awaiter(_this, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        if (!git_watcher_1.GitStatusChangeEvent.is(gitEvent)) return [3 /*break*/, 3];
                                        if (!(gitEvent.status.currentHead !== this.lastHead)) return [3 /*break*/, 2];
                                        this.lastHead = gitEvent.status.currentHead;
                                        _a = this;
                                        return [4 /*yield*/, this.getLastCommit()];
                                    case 1:
                                        _a.lastCommit = _b.sent();
                                        _b.label = 2;
                                    case 2:
                                        this.status = gitEvent.status;
                                        this.updateView(gitEvent.status);
                                        _b.label = 3;
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); }));
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    GitWidget.prototype.storeState = function () {
        var commitTextArea = document.getElementById(GitWidget_1.Styles.COMMIT_MESSAGE);
        var messageBoxHeight = commitTextArea ? commitTextArea.offsetHeight : GitWidget_1.MESSAGE_BOX_MIN_HEIGHT;
        return {
            message: this.message,
            commitMessageValidationResult: this.commitMessageValidationResult,
            messageBoxHeight: messageBoxHeight
        };
    };
    // tslint:disable-next-line:no-any
    GitWidget.prototype.restoreState = function (oldState) {
        this.message = oldState.message;
        this.commitMessageValidationResult = oldState.commitMessageValidationResult;
        this.messageBoxHeight = oldState.messageBoxHeight || GitWidget_1.MESSAGE_BOX_MIN_HEIGHT;
    };
    GitWidget.prototype.undo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var selectedRepository, message, commitTextArea;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        selectedRepository = this.repositoryProvider.selectedRepository;
                        if (!selectedRepository) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.git.exec(selectedRepository, ['log', '-n', '1', '--format=%B'])];
                    case 1:
                        message = (_a.sent()).stdout.trim();
                        commitTextArea = document.getElementById(GitWidget_1.Styles.COMMIT_MESSAGE);
                        return [4 /*yield*/, this.git.exec(selectedRepository, ['reset', 'HEAD~', '--soft'])];
                    case 2:
                        _a.sent();
                        if (commitTextArea) {
                            this.message = message;
                            commitTextArea.value = message;
                            this.resize(commitTextArea);
                            commitTextArea.focus();
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    GitWidget.prototype.commit = function (repository, options, message) {
        if (message === void 0) { message = this.message; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, signOff, amend, status_1, error_1, messageInput;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!repository) return [3 /*break*/, 9];
                        this.commitMessageValidationResult = undefined;
                        if (message.trim().length === 0) {
                            this.commitMessageValidationResult = {
                                status: 'error',
                                message: 'Please provide a commit message'
                            };
                        }
                        _a = this.commitMessageValidationResult === undefined;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.git.status(repository)];
                    case 1:
                        _a = !(_b.sent()).changes.some(function (c) { return c.staged === true; });
                        _b.label = 2;
                    case 2:
                        if (_a) {
                            this.commitMessageValidationResult = {
                                status: 'error',
                                message: 'No changes added to commit'
                            };
                        }
                        if (!(this.commitMessageValidationResult === undefined)) return [3 /*break*/, 8];
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 6, , 7]);
                        signOff = options === 'sign-off';
                        amend = options === 'amend';
                        return [4 /*yield*/, this.git.commit(repository, message, { signOff: signOff, amend: amend })];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, this.git.status(repository)];
                    case 5:
                        status_1 = _b.sent();
                        this.resetCommitMessages();
                        this.updateView(status_1);
                        return [3 /*break*/, 7];
                    case 6:
                        error_1 = _b.sent();
                        this.logError(error_1);
                        return [3 /*break*/, 7];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        messageInput = document.getElementById(GitWidget_1.Styles.COMMIT_MESSAGE);
                        if (messageInput) {
                            this.update();
                            messageInput.focus();
                        }
                        _b.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    GitWidget.prototype.updateView = function (status) {
        return __awaiter(this, void 0, void 0, function () {
            var stagedChanges, unstagedChanges, mergeChanges, _a, _b, change, uri, repository, _c, icon, label, description, e_1_1, sort, e_1, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        stagedChanges = [];
                        unstagedChanges = [];
                        mergeChanges = [];
                        if (!status) return [3 /*break*/, 8];
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 6, 7, 8]);
                        _a = __values(status.changes), _b = _a.next();
                        _e.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 5];
                        change = _b.value;
                        uri = new uri_1.default(change.uri);
                        repository = this.repositoryProvider.selectedRepository;
                        return [4 /*yield*/, Promise.all([
                                this.labelProvider.getIcon(uri),
                                this.labelProvider.getName(uri),
                                repository ? common_1.Repository.relativePath(repository, uri.parent).toString() : this.labelProvider.getLongName(uri.parent)
                            ])];
                    case 3:
                        _c = __read.apply(void 0, [_e.sent(), 3]), icon = _c[0], label = _c[1], description = _c[2];
                        if (common_1.GitFileStatus[common_1.GitFileStatus.Conflicted.valueOf()] !== common_1.GitFileStatus[change.status]) {
                            if (change.staged) {
                                stagedChanges.push(__assign({ icon: icon, label: label, description: description }, change));
                            }
                            else {
                                unstagedChanges.push(__assign({ icon: icon, label: label, description: description }, change));
                            }
                        }
                        else {
                            if (!change.staged) {
                                mergeChanges.push(__assign({ icon: icon, label: label, description: description }, change));
                            }
                        }
                        _e.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        sort = function (l, r) { return l.label.localeCompare(r.label); };
                        this.stagedChanges = stagedChanges.sort(sort);
                        this.unstagedChanges = unstagedChanges.sort(sort);
                        this.mergeChanges = mergeChanges.sort(sort);
                        this.update();
                        return [2 /*return*/];
                }
            });
        });
    };
    GitWidget.prototype.renderCommitMessage = function () {
        var oninput = this.onCommitMessageChange.bind(this);
        var placeholder = 'Commit message';
        var validationStatus = this.commitMessageValidationResult ? this.commitMessageValidationResult.status : 'idle';
        var validationMessage = this.commitMessageValidationResult ? this.commitMessageValidationResult.message : '';
        var autofocus = 'true';
        var id = GitWidget_1.Styles.COMMIT_MESSAGE;
        var commitMessageArea = virtualdom_1.h.textarea({
            className: GitWidget_1.Styles.COMMIT_MESSAGE + " theia-git-commit-message-" + validationStatus,
            style: { height: this.messageBoxHeight + "px" },
            autofocus: autofocus,
            oninput: oninput,
            placeholder: placeholder,
            id: id
        }, this.message);
        var validationMessageArea = virtualdom_1.h.div({
            // tslint:disable-next-line:max-line-length
            className: GitWidget_1.Styles.VALIDATION_MESSAGE + " " + GitWidget_1.Styles.NO_SELECT + " theia-git-validation-message-" + validationStatus + " theia-git-commit-message-" + validationStatus,
            style: {
                display: !!this.commitMessageValidationResult ? 'block' : 'none'
            },
            readonly: 'true'
        }, validationMessage);
        return virtualdom_1.h.div({ className: GitWidget_1.Styles.COMMIT_MESSAGE_CONTAINER }, commitMessageArea, validationMessageArea);
    };
    GitWidget.prototype.onCommitMessageChange = function (e) {
        var _this = this;
        var target = e.target;
        if (target instanceof HTMLTextAreaElement) {
            var value = target.value;
            this.message = value;
            this.resize(target);
            this.validateCommitMessage(value).then(function (result) {
                if (!git_commit_message_validator_1.GitCommitMessageValidator.Result.equal(_this.commitMessageValidationResult, result)) {
                    _this.commitMessageValidationResult = result;
                    _this.update();
                }
            });
        }
    };
    GitWidget.prototype.resize = function (textArea) {
        // tslint:disable-next-line:no-null-keyword
        var fontSize = Number.parseInt(window.getComputedStyle(textArea, undefined).getPropertyValue('font-size').split('px')[0] || '0', 10);
        var value = textArea.value;
        if (Number.isInteger(fontSize) && fontSize > 0) {
            var requiredHeight = fontSize * value.split(/\r?\n/).length;
            if (requiredHeight < textArea.scrollHeight) {
                textArea.style.height = requiredHeight + "px";
            }
        }
        if (textArea.clientHeight < textArea.scrollHeight) {
            textArea.style.height = textArea.scrollHeight + "px";
            if (textArea.clientHeight < textArea.scrollHeight) {
                textArea.style.height = (textArea.scrollHeight * 2 - textArea.clientHeight) + "px";
            }
        }
    };
    GitWidget.prototype.validateCommitMessage = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.commitMessageValidator.validate(input)];
            });
        });
    };
    GitWidget.prototype.render = function () {
        var repository = this.repositoryProvider.selectedRepository;
        var messageInput = this.renderCommitMessage();
        var commandBar = this.renderCommandBar(repository);
        var headerContainer = virtualdom_1.h.div({ className: 'headerContainer' }, messageInput, commandBar);
        var mergeChanges = this.renderMergeChanges(repository) || '';
        var stagedChanges = this.renderStagedChanges(repository) || '';
        var unstagedChanges = this.renderUnstagedChanges(repository) || '';
        var changesContainer = virtualdom_1.h.div({ className: "changesOuterContainer", id: this.scrollContainer }, mergeChanges, stagedChanges, unstagedChanges);
        var lastCommit = this.lastCommit ? virtualdom_1.h.div(virtualdom_1.h.div({ className: GitWidget_1.Styles.LAST_COMMIT_CONTAINER }, this.renderLastCommit())) : '';
        return [headerContainer, changesContainer, lastCommit];
    };
    GitWidget.prototype.createChildContainer = function () {
        var container = _super.prototype.createChildContainer.call(this);
        container.classList.add(GitWidget_1.Styles.MAIN_CONTAINER);
        return container;
    };
    GitWidget.prototype.getLastCommit = function () {
        return __awaiter(this, void 0, void 0, function () {
            var selectedRepository, commits, commit, avatar;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        selectedRepository = this.repositoryProvider.selectedRepository;
                        if (!selectedRepository) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.git.log(selectedRepository, { maxCount: 1, shortSha: true })];
                    case 1:
                        commits = _a.sent();
                        if (!(commits.length > 0)) return [3 /*break*/, 3];
                        commit = commits[0];
                        return [4 /*yield*/, this.avatarService.getAvatar(commit.author.email)];
                    case 2:
                        avatar = _a.sent();
                        return [2 /*return*/, { commit: commit, avatar: avatar }];
                    case 3: return [2 /*return*/, undefined];
                }
            });
        });
    };
    GitWidget.prototype.renderLastCommit = function () {
        var _this = this;
        if (!this.lastCommit) {
            return '';
        }
        var _a = this.lastCommit, commit = _a.commit, avatar = _a.avatar;
        var gravatar = virtualdom_1.h.div({ className: GitWidget_1.Styles.LAST_COMMIT_MESSAGE_AVATAR }, virtualdom_1.h.img({ src: avatar }));
        var summary = virtualdom_1.h.div({ className: GitWidget_1.Styles.LAST_COMMIT_MESSAGE_SUMMARY }, commit.summary);
        var time = virtualdom_1.h.div({ className: GitWidget_1.Styles.LAST_COMMIT_MESSAGE_TIME }, commit.authorDateRelative + " by " + commit.author.name);
        var details = virtualdom_1.h.div({ className: GitWidget_1.Styles.LAST_COMMIT_DETAILS }, summary, time);
        // Yes, a container. Otherwise the button would stretch vertically. And having a bigger `Undo` button than a `Commit` would be odd.
        var buttonContainer = virtualdom_1.h.div({ className: GitWidget_1.Styles.FLEX_CENTER }, virtualdom_1.h.button({
            className: "theia-button",
            title: 'Undo last commit',
            onclick: function () { return _this.undo.bind(_this)(); }
        }, 'Undo'));
        return browser_1.VirtualRenderer.flatten([gravatar, details, buttonContainer]);
    };
    GitWidget.prototype.renderCommandBar = function (repository) {
        var _this = this;
        var refresh = virtualdom_1.h.a({
            className: 'toolbar-button',
            title: 'Refresh',
            onclick: function (e) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.repositoryProvider.refresh()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }
        }, virtualdom_1.h.i({ className: 'fa fa-refresh' }));
        var more = repository ? virtualdom_1.h.a({
            className: 'toolbar-button',
            title: 'More...',
            onclick: function (event) {
                var el = event.target.parentElement;
                if (el) {
                    _this.contextMenuRenderer.render(GitWidget_1.ContextMenu.PATH, {
                        x: el.getBoundingClientRect().left,
                        y: el.getBoundingClientRect().top + el.offsetHeight
                    });
                }
            }
        }, virtualdom_1.h.i({ className: 'fa fa-ellipsis-h' })) : '';
        var signOffBy = repository ? virtualdom_1.h.a({
            className: 'toolbar-button',
            title: 'Add Signed-off-by',
            onclick: function () { return __awaiter(_this, void 0, void 0, function () {
                var selectedRepository, _a, username, email, signOff, commitTextArea, content;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            selectedRepository = this.repositoryProvider.selectedRepository;
                            if (!selectedRepository) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.getUserConfig(selectedRepository)];
                        case 1:
                            _a = __read.apply(void 0, [_b.sent(), 2]), username = _a[0], email = _a[1];
                            signOff = "\n\nSigned-off-by: " + username + " <" + email + ">";
                            commitTextArea = document.getElementById(GitWidget_1.Styles.COMMIT_MESSAGE);
                            if (commitTextArea) {
                                content = commitTextArea.value;
                                if (content.endsWith(signOff)) {
                                    commitTextArea.value = content.substr(0, content.length - signOff.length);
                                }
                                else {
                                    commitTextArea.value = "" + content + signOff;
                                }
                                this.resize(commitTextArea);
                                this.message = commitTextArea.value;
                                commitTextArea.focus();
                            }
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            }); }
        }, virtualdom_1.h.i({ className: 'fa fa-pencil-square-o ' })) : '';
        var commandsContainer = virtualdom_1.h.div({ className: 'buttons' }, refresh, signOffBy, more);
        var commitButton = virtualdom_1.h.button({
            className: 'theia-button',
            title: 'Commit all the staged changes',
            onclick: function () { return _this.commit.bind(_this)(repository); }
        }, 'Commit');
        var commitContainer = virtualdom_1.h.div({ className: 'buttons' }, commitButton);
        var placeholder = virtualdom_1.h.div({ className: 'placeholder' });
        return virtualdom_1.h.div({ id: 'commandBar', className: 'flexcontainer' }, commandsContainer, placeholder, commitContainer);
    };
    GitWidget.prototype.getUserConfig = function (repository) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, username, email;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, Promise.all([
                            this.git.exec(repository, ['config', 'user.name']),
                            this.git.exec(repository, ['config', 'user.email'])
                        ])];
                    case 1:
                        _a = __read.apply(void 0, [(_b.sent()).map(function (result) { return result.stdout.trim(); }), 2]), username = _a[0], email = _a[1];
                        return [2 /*return*/, [username, email]];
                }
            });
        });
    };
    GitWidget.prototype.renderGitItemButtons = function (repository, change) {
        var _this = this;
        var buttons = [];
        if (change.staged) {
            buttons.push(virtualdom_1.h.a({
                className: 'toolbar-button',
                title: 'Unstage Changes',
                onclick: function (event) { return __awaiter(_this, void 0, void 0, function () {
                    var error_2;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, this.git.unstage(repository, change.uri)];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                error_2 = _a.sent();
                                this.logError(error_2);
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); }
            }, virtualdom_1.h.i({ className: 'fa fa-minus' })));
        }
        else {
            buttons.push(virtualdom_1.h.a({
                className: 'toolbar-button',
                title: 'Discard Changes',
                onclick: function (event) { return __awaiter(_this, void 0, void 0, function () {
                    var options, error_3;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                options = { paths: change.uri };
                                if (!(change.status === common_1.GitFileStatus.New)) return [3 /*break*/, 1];
                                this.commandService.executeCommand(browser_3.WorkspaceCommands.FILE_DELETE.id, new uri_1.default(change.uri));
                                return [3 /*break*/, 4];
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, this.git.checkout(repository, options)];
                            case 2:
                                _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                error_3 = _a.sent();
                                this.logError(error_3);
                                return [3 /*break*/, 4];
                            case 4: return [2 /*return*/];
                        }
                    });
                }); }
            }, virtualdom_1.h.i({ className: 'fa fa-undo' })));
            buttons.push(virtualdom_1.h.a({
                className: 'toolbar-button',
                title: 'Stage Changes',
                onclick: function (event) { return __awaiter(_this, void 0, void 0, function () {
                    var error_4;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, this.git.add(repository, change.uri)];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                error_4 = _a.sent();
                                this.logError(error_4);
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); }
            }, virtualdom_1.h.i({ className: 'fa fa-plus' })));
        }
        return virtualdom_1.h.div({ className: 'buttons' }, browser_1.VirtualRenderer.flatten(buttons));
    };
    GitWidget.prototype.renderGitItem = function (repository, change) {
        var _this = this;
        if (!repository) {
            return '';
        }
        var iconSpan = virtualdom_1.h.span({ className: change.icon + ' file-icon' });
        var nameSpan = virtualdom_1.h.span({ className: 'name' }, change.label + ' ');
        var pathSpan = virtualdom_1.h.span({ className: 'path' }, change.description);
        var nameAndPathDiv = virtualdom_1.h.div({
            className: 'noWrapInfo',
            onclick: function () { return _this.openChange(change); }
        }, iconSpan, nameSpan, pathSpan);
        var buttonsDiv = this.renderGitItemButtons(repository, change);
        var staged = change.staged ? 'staged ' : '';
        var statusDiv = virtualdom_1.h.div({
            title: this.getStatusCaption(change.status, change.staged),
            className: 'status ' + staged + common_1.GitFileStatus[change.status].toLowerCase()
        }, this.getAbbreviatedStatusCaption(change.status, change.staged));
        var itemButtonsAndStatusDiv = virtualdom_1.h.div({ className: 'itemButtonsContainer' }, buttonsDiv, statusDiv);
        return virtualdom_1.h.div({ className: 'gitItem noselect' }, nameAndPathDiv, itemButtonsAndStatusDiv);
    };
    GitWidget.prototype.renderChangesHeader = function (title) {
        var stagedChangesHeaderDiv = virtualdom_1.h.div({ className: 'header' }, title);
        return stagedChangesHeaderDiv;
    };
    GitWidget.prototype.renderMergeChanges = function (repository) {
        var _this = this;
        var mergeChangeDivs = [];
        if (this.mergeChanges.length > 0) {
            this.mergeChanges.forEach(function (change) {
                mergeChangeDivs.push(_this.renderGitItem(repository, change));
            });
            return virtualdom_1.h.div({
                id: 'mergeChanges',
                className: 'changesContainer'
            }, virtualdom_1.h.div({ className: 'theia-header' }, 'Merge Changes'), browser_1.VirtualRenderer.flatten(mergeChangeDivs));
        }
        else {
            return undefined;
        }
    };
    GitWidget.prototype.renderStagedChanges = function (repository) {
        var _this = this;
        var stagedChangeDivs = [];
        if (this.stagedChanges.length > 0) {
            this.stagedChanges.forEach(function (change) {
                stagedChangeDivs.push(_this.renderGitItem(repository, change));
            });
            return virtualdom_1.h.div({
                id: 'stagedChanges',
                className: 'changesContainer'
            }, virtualdom_1.h.div({ className: 'theia-header' }, 'Staged Changes'), browser_1.VirtualRenderer.flatten(stagedChangeDivs));
        }
        else {
            return undefined;
        }
    };
    GitWidget.prototype.renderUnstagedChanges = function (repository) {
        var _this = this;
        var unstagedChangeDivs = [];
        if (this.unstagedChanges.length > 0) {
            this.unstagedChanges.forEach(function (change) {
                unstagedChangeDivs.push(_this.renderGitItem(repository, change));
            });
            return virtualdom_1.h.div({
                id: 'unstagedChanges',
                className: 'changesContainer'
            }, virtualdom_1.h.div({ className: 'theia-header' }, 'Changed'), browser_1.VirtualRenderer.flatten(unstagedChangeDivs));
        }
        return undefined;
    };
    // tslint:disable-next-line:no-any
    GitWidget.prototype.logError = function (error) {
        var message = error instanceof Error ? error.message : error;
        this.messageService.error(message);
    };
    GitWidget.prototype.getStatusCaption = function (status, staged) {
        return common_1.GitFileStatus.toString(status, staged);
    };
    GitWidget.prototype.getAbbreviatedStatusCaption = function (status, staged) {
        return common_1.GitFileStatus.toAbbreviation(status, staged);
    };
    GitWidget.prototype.findChange = function (uri) {
        var stringUri = uri.toString();
        var merge = this.mergeChanges.find(function (c) { return c.uri.toString() === stringUri; });
        if (merge) {
            return merge;
        }
        var unstaged = this.unstagedChanges.find(function (c) { return c.uri.toString() === stringUri; });
        if (unstaged) {
            return unstaged;
        }
        return this.stagedChanges.find(function (c) { return c.uri.toString() === stringUri; });
    };
    GitWidget.prototype.openChange = function (change, options) {
        return __awaiter(this, void 0, void 0, function () {
            var changeUri;
            return __generator(this, function (_a) {
                changeUri = this.createChangeUri(change);
                return [2 /*return*/, this.editorManager.open(changeUri, options)];
            });
        });
    };
    GitWidget.prototype.createChangeUri = function (change) {
        var changeUri = new uri_1.default(change.uri);
        if (change.status !== common_1.GitFileStatus.New) {
            if (change.staged) {
                return browser_1.DiffUris.encode(changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME).withQuery('HEAD'), changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME), changeUri.displayName + ' (Index)');
            }
            if (this.stagedChanges.find(function (c) { return c.uri === change.uri; })) {
                return browser_1.DiffUris.encode(changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME), changeUri, changeUri.displayName + ' (Working tree)');
            }
            if (this.mergeChanges.find(function (c) { return c.uri === change.uri; })) {
                return changeUri;
            }
            return browser_1.DiffUris.encode(changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME).withQuery('HEAD'), changeUri, changeUri.displayName + ' (Working tree)');
        }
        if (change.staged) {
            return changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME);
        }
        if (this.stagedChanges.find(function (c) { return c.uri === change.uri; })) {
            return browser_1.DiffUris.encode(changeUri.withScheme(git_resource_1.GIT_RESOURCE_SCHEME), changeUri, changeUri.displayName + ' (Working tree)');
        }
        return changeUri;
    };
    GitWidget.prototype.resetCommitMessages = function () {
        this.message = '';
        var messageInput = document.getElementById(GitWidget_1.Styles.COMMIT_MESSAGE);
        messageInput.value = '';
        this.resize(messageInput);
    };
    GitWidget.MESSAGE_BOX_MIN_HEIGHT = 25;
    __decorate([
        inversify_1.inject(browser_2.EditorManager),
        __metadata("design:type", browser_2.EditorManager)
    ], GitWidget.prototype, "editorManager", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], GitWidget.prototype, "init", null);
    GitWidget = GitWidget_1 = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(common_1.Git)),
        __param(1, inversify_1.inject(git_watcher_1.GitWatcher)),
        __param(2, inversify_1.inject(browser_1.ContextMenuRenderer)),
        __param(3, inversify_1.inject(core_1.ResourceProvider)),
        __param(4, inversify_1.inject(core_1.MessageService)),
        __param(5, inversify_1.inject(core_1.CommandService)),
        __param(6, inversify_1.inject(git_repository_provider_1.GitRepositoryProvider)),
        __param(7, inversify_1.inject(browser_1.LabelProvider)),
        __param(8, inversify_1.inject(browser_3.WorkspaceService)),
        __param(9, inversify_1.inject(git_avatar_service_1.GitAvatarService)),
        __param(10, inversify_1.inject(git_commit_message_validator_1.GitCommitMessageValidator)),
        __metadata("design:paramtypes", [Object, git_watcher_1.GitWatcher, Object, Function, core_1.MessageService, Object, git_repository_provider_1.GitRepositoryProvider,
            browser_1.LabelProvider,
            browser_3.WorkspaceService,
            git_avatar_service_1.GitAvatarService,
            git_commit_message_validator_1.GitCommitMessageValidator])
    ], GitWidget);
    return GitWidget;
    var GitWidget_1;
}(browser_1.VirtualWidget));
exports.GitWidget = GitWidget;
(function (GitWidget) {
    var ContextMenu;
    (function (ContextMenu) {
        ContextMenu.PATH = ['git-widget-context-menu'];
        ContextMenu.OTHER_GROUP = __spread(ContextMenu.PATH, ['1_other']);
        ContextMenu.COMMIT_GROUP = __spread(ContextMenu.PATH, ['2_commit']);
    })(ContextMenu = GitWidget.ContextMenu || (GitWidget.ContextMenu = {}));
    var Styles;
    (function (Styles) {
        Styles.MAIN_CONTAINER = 'theia-git-main-container';
        Styles.COMMIT_MESSAGE_CONTAINER = 'theia-git-commit-message-container';
        Styles.COMMIT_MESSAGE = 'theia-git-commit-message';
        Styles.VALIDATION_MESSAGE = 'theia-git-commit-validation-message';
        Styles.LAST_COMMIT_CONTAINER = 'theia-git-last-commit-container';
        Styles.LAST_COMMIT_DETAILS = 'theia-git-last-commit-details';
        Styles.LAST_COMMIT_MESSAGE_AVATAR = 'theia-git-last-commit-message-avatar';
        Styles.LAST_COMMIT_MESSAGE_SUMMARY = 'theia-git-last-commit-message-summary';
        Styles.LAST_COMMIT_MESSAGE_TIME = 'theia-git-last-commit-message-time';
        Styles.FLEX_CENTER = 'flex-container-center';
        Styles.NO_SELECT = 'no-select';
    })(Styles = GitWidget.Styles || (GitWidget.Styles = {}));
})(GitWidget = exports.GitWidget || (exports.GitWidget = {}));
exports.GitWidget = GitWidget;
//# sourceMappingURL=git-widget.js.map