import { h } from "@phosphor/virtualdom";
import { Widget } from "@phosphor/widgets";
import { LabelProvider } from "@wiptheia/core/lib/browser";
import { Git, GitFileChange } from "../../common";
import { GitDiffWidget } from "../diff/git-diff-widget";
import { GitRepositoryProvider } from "../git-repository-provider";
import { GitFileChangeNode } from "../git-widget";
export declare const GIT_COMMIT_DETAIL = "git-commit-detail-widget";
export interface GitCommitDetails {
    readonly authorName: string;
    readonly authorEmail: string;
    readonly authorDate: Date;
    readonly authorDateRelative: string;
    readonly authorAvatar: string;
    readonly commitMessage: string;
    readonly messageBody?: string;
    readonly fileChangeNodes: GitFileChangeNode[];
    readonly commitSha: string;
}
export declare const GitCommitDetailWidgetOptions: unique symbol;
export interface GitCommitDetailWidgetOptions extends GitCommitDetails {
    readonly range: Git.Options.Range;
}
export declare class GitCommitDetailWidget extends GitDiffWidget {
    protected readonly repositoryProvider: GitRepositoryProvider;
    protected readonly labelProvider: LabelProvider;
    protected readonly commitDetailOptions: GitCommitDetailWidgetOptions;
    constructor(repositoryProvider: GitRepositoryProvider, labelProvider: LabelProvider, commitDetailOptions: GitCommitDetailWidgetOptions);
    protected renderDiffListHeader(): h.Child;
    protected ref: Widget | undefined;
    protected revealChange(change: GitFileChange): Promise<void>;
}
