import { MenuModelRegistry, CommandRegistry, Command, SelectionService } from '@wiptheia/core';
import { AbstractViewContribution } from '@wiptheia/core/lib/browser';
import { UriCommandHandler, UriAwareCommandHandler } from '@wiptheia/core/lib/common/uri-command-handler';
import URI from '@wiptheia/core/lib/common/uri';
import { GitHistoryWidget } from './git-history-widget';
import { GitRepositoryTracker } from '../git-repository-tracker';
export declare namespace GitHistoryCommands {
    const OPEN_FILE_HISTORY: Command;
    const OPEN_BRANCH_HISTORY: Command;
}
export declare const GIT_HISTORY = "git-history";
export declare const GIT_HISTORY_MAX_COUNT = 100;
export declare class GitHistoryContribution extends AbstractViewContribution<GitHistoryWidget> {
    protected readonly selectionService: SelectionService;
    protected readonly repositoryTracker: GitRepositoryTracker;
    constructor();
    protected init(): void;
    registerMenus(menus: MenuModelRegistry): void;
    registerCommands(commands: CommandRegistry): void;
    showWidget(uri: string | undefined): Promise<void>;
    protected refreshWidget(uri: string | undefined): Promise<void>;
    protected newUriAwareCommandHandler(handler: UriCommandHandler<URI>): UriAwareCommandHandler<URI>;
}
