"use strict";
/*
 * Copyright (C) 2018 TypeFox and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 */
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var git_history_contribution_1 = require("./git-history-contribution");
var inversify_1 = require("inversify");
var core_1 = require("@wiptheia/core");
var keybinding_1 = require("@wiptheia/core/lib/browser/keybinding");
var browser_1 = require("@wiptheia/core/lib/browser");
var git_history_widget_1 = require("./git-history-widget");
var git_commit_detail_widget_1 = require("./git-commit-detail-widget");
var git_avatar_service_1 = require("./git-avatar-service");
require("../../../src/browser/style/history.css");
require("../../../src/browser/style/git-icons.css");
var git_commit_detail_open_handler_1 = require("./git-commit-detail-open-handler");
function bindGitHistoryModule(bind) {
    bind(git_avatar_service_1.GitAvatarService).toSelf().inSingletonScope();
    bind(git_history_widget_1.GitHistoryWidget).toSelf();
    bind(browser_1.WidgetFactory).toDynamicValue(function (ctx) { return ({
        id: git_history_contribution_1.GIT_HISTORY,
        createWidget: function () { return ctx.container.get(git_history_widget_1.GitHistoryWidget); }
    }); });
    bind(browser_1.WidgetFactory).toDynamicValue(function (ctx) { return ({
        id: git_commit_detail_widget_1.GIT_COMMIT_DETAIL,
        createWidget: function (options) {
            var child = new inversify_1.Container({ defaultScope: 'Singleton' });
            child.parent = ctx.container;
            child.bind(git_commit_detail_widget_1.GitCommitDetailWidget).toSelf();
            child.bind(git_commit_detail_widget_1.GitCommitDetailWidgetOptions).toConstantValue(options);
            return child.get(git_commit_detail_widget_1.GitCommitDetailWidget);
        }
    }); });
    bind(git_commit_detail_open_handler_1.GitCommitDetailOpenHandler).toSelf();
    bind(browser_1.OpenHandler).toDynamicValue(function (ctx) { return ctx.container.get(git_commit_detail_open_handler_1.GitCommitDetailOpenHandler); });
    bind(git_history_contribution_1.GitHistoryContribution).toSelf().inSingletonScope();
    try {
        for (var _a = __values([core_1.CommandContribution, core_1.MenuContribution, keybinding_1.KeybindingContribution]), _b = _a.next(); !_b.done; _b = _a.next()) {
            var identifier = _b.value;
            bind(identifier).toDynamicValue(function (ctx) {
                return ctx.container.get(git_history_contribution_1.GitHistoryContribution);
            }).inSingletonScope();
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var e_1, _c;
}
exports.bindGitHistoryModule = bindGitHistoryModule;
//# sourceMappingURL=git-history-frontend-module.js.map