import { ReferenceCollection, Reference } from "@wiptheia/core";
import { Repository } from '../common';
import { GitRepositoryWatcher, GitRepositoryWatcherFactory } from "./git-repository-watcher";
export declare class GitRepositoryManager {
    protected readonly watcherFactory: GitRepositoryWatcherFactory;
    protected readonly watchers: ReferenceCollection<Repository, GitRepositoryWatcher>;
    run<T>(repository: Repository, op: () => Promise<T>): Promise<T>;
    getWatcher(repository: Repository): Promise<Reference<GitRepositoryWatcher>>;
    protected ensureSync<T>(repository: Repository, result: Promise<T>): Promise<T>;
    sync(repository: Repository): Promise<void>;
}
